// var { biquadNodes, audioListener } = require("./audio_handler.js");

var { biquadNodes, audioListener } = require('./audio_handler.js')

var filterStates = {
    gains: { fullness: 0, clarity: 0, harshness: 0 },
    centerFreq: { fullness: 200, clarity: 3500, harshness: 8500 }
}
var featureStates = { voiceTouchUp: false, suppressNoise: true, spatialAudio: true }

// export const defaultMaxAttenuationdB = -12.0


var voiceTouchUpEnable = function() {
    console.log("Sliders enabled")

    biquadNodes.clarity.gain.value = filterStates.gains.clarity
    biquadNodes.fullness.gain.value = filterStates.gains.fullness

    biquadNodes.harshness.gain.value = filterStates.gains.harshness;

    biquadNodes.LFNoise.frequency.value = 90;
}

var voiceTouchUpDisable = function() {
    console.log("Sliders disabled")

    biquadNodes.clarity.gain.value = 0
    biquadNodes.fullness.gain.value = 0

    biquadNodes.harshness.gain.value = 0

    biquadNodes.LFNoise.frequency.value = 0;
}



var applyNewGainClarity = function(value) {
    filterStates.gains.clarity = value
    biquadNodes.clarity.gain.value = filterStates.gains.clarity

    console.log("Clarity changed by slider", biquadNodes.clarity.gain.value)
}

var applyNewGainFullness = function(value) {
    filterStates.gains.fullness = value
    biquadNodes.fullness.gain.value = filterStates.gains.fullness

    console.log("Fullness changed by slider", biquadNodes.fullness.gain.value)
}


var setSpatialNodeListenerPosition2D = function(x, y) {

    audioListener.positionX.value = -x
        // audioContext.listener.positionz.value = -y
    audioListener.positionY.value = -y



}

var updateNoiseSuppressionState = function(value) {
    featureStates.suppressNoise = value

    if (featureStates.suppressNoise)
        console.log("noise reduction is on")
    else
        console.log("noise reduction is off")
}


module.exports = { featureStates, filterStates, updateNoiseSuppressionState }